import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.*;

public class Kussmund extends Actor
{
    private int gekuessteFroschkoenige = 0;
    private double gesammeltesGeld = 0;
    public Kussmund()
    {
    }

    public void act() 
    {
        this.maussteuerung();
        this.froschKollisionChecken();
    }    

    public int zaehleFroschkoenigeAufWelt()
    {
        int anzahlFroschkoenige = 0;
        List<Frosch> froschliste = this.getWorld().getObjects(Frosch.class);
        for(Frosch einFrosch : froschliste) {
            // In der folgenden Zeile Getter und/oder Setter verwenden!
            if(einFrosch.istEinFroschkoenig == true)
            {
                // In der folgenden Zeile Getter und/oder Setter verwenden!
                anzahlFroschkoenige += 1; // gleich wie: anzahlFroschkoenige = anzahlFroschkoenige + 1
            }
        }
        return anzahlFroschkoenige;
    }

    public void froschKollisionChecken()
    {

        if(this.isTouching(Frosch.class) && Greenfoot.mousePressed(null))
        {
            Frosch f = (Frosch)this.getOneIntersectingObject(Frosch.class);
            /*
             * IHR JOB
             * 1) In Klasse Frosch + Krone Attribute private machen, Getter + Setter schreiben (wo nötig)
             * 2) In dieser Klasse »Kussmund« Getter und/oder Setter verwenden
             * 3) Zusatzaufgabe: Für Attribute DIESER Klasse Kussmund Getter + Setter schreiben und konsequent verwenden.
             * 
             */

            // In der folgenden Zeile Getter und/oder Setter verwenden!
            if(f.istSichtbar)
            /*
             * --------------------------------------------
             * Prüfung: Ist Frosch sichtbar? Nur dann bewirkt Klick etwas
             * --------------------------------------------
             */
            {
                // In der folgenden Zeile Getter und/oder Setter verwenden!
                // Tipp: f.setAnzahlGeklickt(_neuerWert_) - neuer Wert ergibt sich aus altem Wert + 1
                f.anzahlGeklickt = f.anzahlGeklickt + 1;

                // In der folgenden Zeile Getter und/oder Setter verwenden!
                if(f.istEinFroschkoenig)
                /*
                 * --------------------------------------------
                 * Fall 1: Ein Froschkönig wurde angeklickt
                 * --------------------------------------------
                 */
                {
                    this.gekuessteFroschkoenige++; // entspricht this.gekuessteFroschkoenige = this.gekuessteFroschkoenige + 1;

                    GreenfootImage bild = f.getImage();
                    f.setLocation(this.getWorld().getWidth()/2, this.getWorld().getHeight()/2);
                    bild.scale(bild.getWidth() * 3, bild.getHeight() * 3);
                    bild.setFont(new Font(true, false, 30));

                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    bild.drawString(f.name, bild.getWidth()/3, bild.getHeight() - 50);
                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    String nameDesFroschkoenigs = f.name;

                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    double goldDesFroschkoenigs = f.seineKrone.wert;

                    this.gesammeltesGeld += goldDesFroschkoenigs; // x += 2 entspricht x = x + 1
                    this.textAusgeben(nameDesFroschkoenigs + " geküsst und " + goldDesFroschkoenigs + " Gold abgezogen!");

                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    this.textAusgeben(
                        "Wow - die Krone von " + nameDesFroschkoenigs + " ist aus " + f.seineKrone.material + ".\n" +
                        "Hergestellt im Jahre " + f.seineKrone.herstellungsjahr + " A. D. !!!!"                
                    );

                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    f.name = f.name + " (geküsst)";

                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    this.textAusgeben("Geküsster Frosch heißt jetzt \"" + f.name + "\"");
                    // Backslash im String (\) führt dazu, dass das nächste Zeichen nicht interpretiert, sondern angezeigt wird
                    // Text in Anführungszeichen geben wir also aus mit "Er sagt \"Hallo\"." - Das nennen wir Escaping.
                    this.getWorld().removeObject(f);

                    this.textAusgeben(
                        "Du hast jetzt " + this.gesammeltesGeld + " Goldstücke!\n" + 
                        "Noch " + this.zaehleFroschkoenigeAufWelt() + " Froschkönige zu küssen"
                    );

                    if(this.zaehleFroschkoenigeAufWelt() == 0)
                    {
                        this.textAusgeben("Gewonnen!");
                        Greenfoot.stop();
                    }
                } 
                // In der folgenden Zeile Getter und/oder Setter verwenden!
                else if(!f.istEinFroschkoenig)
                /*
                 * --------------------------------------------
                 * Fall 2: Ein normaler Frosch wurde angeklickt
                 * --------------------------------------------
                 */
                {
                    // In der folgenden Zeile Getter und/oder Setter verwenden!
                    this.textAusgeben("Daneben!\nAuf diesen Frosch hast du schon " + f.anzahlGeklickt + " mal geklickt!!");
                }
            }
        }
    }

    public void textAusgeben(String ausgabe)
    {
        this.getWorld().showText(ausgabe, this.getWorld().getWidth()/2, this.getWorld().getWidth()/2);
        Greenfoot.delay(180);
        this.getWorld().showText("", this.getWorld().getWidth()/2, this.getWorld().getWidth()/2);

    }

    public void maussteuerung()
    {
        MouseInfo m = Greenfoot.getMouseInfo();
        if(m != null)
        {
            this.setLocation(m.getX(), m.getY());
        }

    }
}